import { Action } from 'vuex';
export interface Model<Self, R> {
    getNew(): Self;
    fillModel(raw: R): Self;
    getRaw(): R;
}
export declare enum RequestState {
    Pending = 0,
    Success = 1,
    Error = 2,
    Cancelled = 3,
    NotStarted = 4
}
interface FetcherState {
    vuexFetchersState: Map<string, Map<string, RequestState>>;
}
export default class<S extends FetcherState, RS> {
    createSingleFetcher<P, R, M extends Model<M, R>>(force: boolean, mutationName: string, call: (payload: P) => Promise<R>, modelFactory: () => M): Action<S, RS>;
    createBulkFetcher<P, R, M extends Model<M, R>>(force: boolean, mutationName: string, call: (payload: P) => Promise<R[]>, modelFactory: () => M): Action<S, RS>;
    createStateInvalidator<P>(mutationName: string): Action<S, RS>;
    private createFetcher;
    private getRequestState;
    private setRequestState;
}
export {};
